unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Lp: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    Timer1: TTimer;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Label5: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Label6: TLabel;
    Button3: TButton;
    Label7: TLabel;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  tempo: integer;
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Anfangswerte setzen.
  randomize; //Ntig wann immer wenn random bentigt wird.
  label1.Caption := //Ein label mit Zeilumbruch.
  'Eugen hat eine Aktie A im Wert von 1000 EUR. Josef hat 1000 EUR bar.'#13+
  'Tglich wechselt die Aktie den Besitzer. Der Wert der Aktie kann'#13+
  'tglich um maximal p% nach oben oder unten schwanken.'#13+
  'Wieviel hat jeder? Negativer Besitz heit: Geld geliehen. Steigt/fllt'#13+
  'der Wert der Aktie ist der Besitz von Eugen + Josef hher/geringer.'#13+
  '(In Wahrheit ist die Aktie nichts wert, nur wissen die beiden es nicht.'#13+
  ' Zusammen besitzen sie -auch nach der Umverteilung- 1000 EUR)';
  //Hier sind die Anfangswerte sichtbar
  edit1.text := '5';       //Anfangswert p
  edit2.Text := '1000';    //Eugen bar
  edit3.text := '0';       //Josef bar
  edit4.text := '0';       //Eugen Aktie
  edit5.text := '1000';    //Aktie von Josef
  edit6.text := '';        //Summe Eugen
  edit7.text := '';        //Summe Joasef
  label5.Caption := '0';   //Zhler
  timer1.Enabled := false; //Disabled
  tempo := 512;            //Millisekunten
  button4.Caption := 'Schneller'; //Knopf, der Timer steuert.
end;

procedure TForm1.Button1Click(Sender: TObject); //Sart-Weiter-Knopf
begin
  if button1.Caption = 'Stop' then Begin //"Stop" wurde angeklickt.
     timer1.Enabled := false;            //Timer auer Betrieb
     button1.Caption := 'Weiter';        //Als nchstes kann "Weiter" angeklickt werden.
  End else Begin //"Start" oder "weiter" wurde angeklickt.
    timer1.Enabled := true;             //Timer in Betrieb
    button1.Caption := 'Stop';           //Als nchstes kann "Stop" angeklickt werden.
  End;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
   var eug, jos, eug_a, jos_a, vol: real;
begin
  label5.Caption := IntToStr(StrToInt(label5.caption) + 1); //Zhler
  eug := strToFloat(edit2.text);   //Kapital von Eugen bar
  jos := strToFloat(edit3.text);   //Kapital von Josef
  eug_a := strToFloat(edit4.text); //Wert der Aktie von Eugen
  jos_a := strToFloat(edit5.text); //Wert der Aktie von Josef
  vol := StrToFloat(edit1.Text)*(2*random-1); //Volatilitt maximal +/- p/100
  vol := round(10*vol)/10;         //Gerundet auf 1 Dezimale
  label7.Caption := Formatfloat('0.###',vol)+ ' %';  //Zum Beispiel -2,4%
  if jos_a > 0 then Begin         //Eugen kauft von Josef die Aktie
    eug_a := jos_a*(1 + vol/100); //Jetzt hat Eugen die Aktie zum Tageskurs
    eug   := eug - eug_a;         //.. und  zahlt den Kaufpreis.
    jos   := jos + eug_a;         //Josef erhlt den Kaufpreis
    jos_a := 0;                   //.. und hat keine Aktie mehr.
  End else Begin                  //Josef kauft von Eugen die Aktie
    jos_a := eug_a*(1 + vol/100); //Jetzt hat Josef die Aktie zum Tageskurs
    jos   := jos - jos_a;         //.. und  zahlt den Kaufpreis.
    eug   := eug + jos_a;         //Eugen erhlt den Kaufpreis
    eug_a := 0;                   //.. und hat keine Aktie mehr.
  End; //Berechnung klar?
  edit2.text := formatfloat('0.##',eug);   //Besitz schreiben. Siehe oben.
  edit3.text := formatfloat('0.##',jos);
  edit4.text := formatfloat('0.##',eug_a);
  edit5.text := formatfloat('0.##',jos_a);
  edit6.text := formatfloat('0',eug+eug_a); //Zusammen
  edit7.text := formatfloat('0',jos+jos_a);
  application.ProcessMessages;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  tempo := tempo div 2;
  if tempo <= 1 then tempo := 1;
  timer1.Interval := tempo;
  button4.Caption := intToStr(tempo) + 'ms';
end;

end.
